///////////////////////////////////////////////////////////////////////////
//
//
//
//
///////////////////////////////////////////////////////////////////////////
Function Mariadb_CreaSelect( csxDbfName )
      Local ccNamefld := Space(20)
      Local cxTable   := ""
      Local mDbfName
      Local mAlias, aStruct := {}, i, mesg := "", mCdx := "", n
      mDbfName     := csxDbfName
      if  empty(mDbfName)
          return nil
      endif
      ccNameWin := GenNewNameModal()
      cxTable  := GetOnlyNameTab(mDbfName)
      mAlias   := GetAlias(mDbfName)
      use &mDbfName alias &mAlias
      aStruct  := dbstruct()
      //
      mesg += REPLICATE("/", 76)  + hb_OsNewLine() + ;
              "// Nombre.....: " + mAlias + "_CreaSQLTab()" + hb_OsNewLine() + ;
              "// Autor......: By HBGenCode Sic Sic!" + hb_OsNewLine() + ;
              "// Fecha......: " + DTOC(Date())  + hb_OsNewLine() + ;
              "// Version....: 1.0.1(R)"  + hb_OsNewLine() + ;
              REPLICATE("/", 76)  + hb_OsNewLine()
      mesg += "FUNCTION " + mAlias + "_CreaSQLTab()"
      mesg += CRLF+"     LOCAL oQuery, oRow, i, aQuery := {}"
      mesg += CRLF+"     LOCAL csDDL := " +  Chr(34) + "DROP TABLE   " + mAlias + " IF EXISTS; " + Chr(34) + " + ;"
      mesg += CRLF+"                    " +  Chr(34) + "CREATE TABLE " + mAlias + " ( " + Chr(34) + " + ;"
      for i := 1 to len(aStruct)
              ccNamefld := Chr(34) + alltrim(aStruct[i, 1]) + "                "
              mesg += CRLF
              mesg += "                    " + SubStr(ccNamefld,1, 16)
              mesg += GetSQlDataType( aStruct[i, 2], aStruct[i, 3], aStruct[i, 4] )
              if i < len(aStruct)
                   mesg += "  NOT NULL , " + Chr(34) + " + ;"
              else
                   mesg += "  NOT NULL ) );" + Chr(34)
              endif
      next
      mesg += CRLF
      mesg += CRLF+"     oQuery := oServer:Query( + csDDL +  )"
      mesg += CRLF+"     IF  oQuery:NetErr()"
      mesg += CRLF+"          MsgStop ( oQuery:Error() )"
      mesg += CRLF+"          Return NIL"
      mesg += CRLF+"     ENDIF"
      mesg += CRLF+"     IF  oQuery:LastRec() > 0"
      mesg += CRLF + REPLICATE(" ", 10)
      mesg += CRLF+"         DEFINE WINDOW " + ccNameWin + " AT 00, 00 WIDTH nWidth HEIGHT 800 ;"
      mesg += CRLF+"                TITLE " + DobleComilla( mAlias ) + ";"
      mesg += CRLF+"                MODAL"
      mesg += CRLF+"                "
      mesg += CRLF+"                "
      mesg += CRLF+"                "
      mesg += CRLF+"         END WINDOW"
      mesg += CRLF+"         CENTER WINDOW " + ccNameWin
      mesg += CRLF+"         ACTIVATE WINDOW " + ccNameWin
      mesg += CRLF + REPLICATE(" ", 10)
      mesg += CRLF+"     ENDIF"
      mesg += CRLF + "RETURN Nil"               // mesg += CRLF + "RETURN( csDDL )"
      select &mAlias
      use
      // vnmain.accodigo.value := mesg
RETURN( mesg )
///////////////////////////////////////////////////////////////////////////
//
//
//
//
///////////////////////////////////////////////////////////////////////////
Function Mariadb_CreaArray( mDbfName  )
      Local ccNamefld := Space(20)
      Local cxTable   := ""
      Local ccCondicion := ""
      local mAlias, aStruct := {}, i, mesg := "", mCdx := "", n
      if  empty(mDbfName)
          return nil
      endif
      cxTable  := GetOnlyNameTab(mDbfName)
      mAlias   := GetAlias(mDbfName)
      use &mDbfName alias &mAlias
      aStruct  := dbstruct()
      //
      mesg += REPLICATE("/", 76)  + hb_OsNewLine() + ;
              "// Nombre.....: " + mAlias + "_CreaArray()" + hb_OsNewLine() + ;
              "// Autor......: By HBGenCode Sic Sic!" + hb_OsNewLine() + ;
              "// Fecha......: " + DTOC(Date())  + hb_OsNewLine() + ;
              "// Version....: 1.0.1(R)"  + hb_OsNewLine() + ;
              REPLICATE("/", 76)  + hb_OsNewLine()
      mesg += "FUNCTION " + mAlias + "_CreaArray()"
      mesg += CRLF+"     LOCAL csDDL := " +  Chr(34) + "SELECT " // + Chr(34) + " + ;"
      for i := 1 to len(aStruct)
              IF  i = 1
                  ccCondicion := alltrim(aStruct[i, 1])
                  ccNamefld := alltrim(aStruct[i, 1])
              ELSE
                  mesg += CRLF
                  ccNamefld := Chr(34) + alltrim(aStruct[i, 1])
              ENDIF
              IF i < len(aStruct)
                   IF  i = 1
                       mesg += ALLTRIM(ccNamefld) + " , " + Chr(34) + " + ;"
                   ELSE
                       mesg += "                           " + ALLTRIM(ccNamefld) + " , " + Chr(34) + " + ;"
                   ENDIF
              ELSE
                   mesg += "                           " + ALLTRIM(ccNamefld)
              ENDIF
              IF i = len(aStruct)
                   mesg += " FROM " +  mAlias + " ORDER BY " + ccCondicion + ";" + Chr(34)
              endif
      next
      mesg += CRLF
      mesg += CRLF + "RETURN( csDDL )"
      // vnmain.abcodigo.value := mesg
      select &mAlias
      use
RETURN( mesg )
FUNCTION GetSQlDataleng( indbfLen, indbfDec )
RETURN(ccSQLTipo)
FUNCTION GetSQlDataType( cdbfTipo, indbfLen, indbfDec )
    LOCAL ccSQLTipo
    IF     cdbfTipo=="C"
        if indbfLen<5
            ccSQLTipo:="CHAR     (" + str(indbfLen, 3, 0) + ")"
        else
            ccSQLTipo:="VARCHAR  (" + str(indbfLen, 3, 0) + ")"
        endif
    ELSEIF cdbfTipo=="N"
        if indbfLen<5
            ccSQLTipo:="SMALLINT (" + str(indbfLen, 3, 0) + ")"
        elseif indbfLen<8
            ccSQLTipo:="INTEGER  (" + str(indbfLen, 3, 0) + ")"
        else
            ccSQLTipo:="LONGINT  (" + str(indbfLen, 3, 0) + ")"
        endif
        if indbfDec>0
            ccSQLTipo:="DECIMAL  (" + str(indbfLen, 3, 0) + "," + str(indbfDec, 2, 0) + ")"
        endif
    ELSEIF cdbfTipo=="D"
        ccSQLTipo:="VARCHAR  ( 08)"
    ELSEIF cdbfTipo=="L"
        ccSQLTipo:="SMALLINT      "
    ELSEIF cdbfTipo=="M"
        ccSQLTipo:="TEXT          "
    ELSEIF cdbfTipo=="U"
        ccSQLTipo:="VARCHAR  (" + str(indbfLen, 3, 0) + ")"
    ELSEIF cdbfTipo=="O"
        ccSQLTipo:="BLOB         "
    ENDIF
RETURN(ccSQLTipo)
